cc_disk_setup: fs_setup with cmd doesn't work

Bug #1687712 reported by Paul Meyer on 2017-05-02
10
This bug affects 1 person
Affects Status Importance Assigned to Milestone
cloud-init
Medium
Paul Meyer
cloud-init (Ubuntu)
Medium
Vishnu C
Xenial
Medium
Unassigned
Yakkety
Medium
Unassigned
Zesty
Medium
Unassigned

Bug Description

=== Begin SRU Template ===
[Impact]
If the user specifies cloud-config with a 'fs_setup' entry containing
a 'cmd', then warning will appear in cloud-init.log and expected filesystem
will not be created.

This is because cloud-init would essentially try to execute a name like:
  "mkfs -t TYPE -L LABEL DEVICE"
rather than a name 'mkfs' with arguments '-t', TYPE, ...
No split was done on space. The fix was to enable
shell intrepretation so that the split would be done.

[Test Case]
This test case assumes a disk will be attached named '/dev/vdb'.
You can change the 'dev=' to be 'sdb' if that will be the device name.
The test cases boots an instance, ads proposed and then 'cleans' the
instance, but similarly this will work if the config is provided
in user-data.

$ dev=vdb
$ sudo tee /etc/cloud/cloud.cfg.d/disk-setup.cfg <<EOF
#cloud-config
disk_setup:
  /dev/$dev:
    table_type: gpt
    layout: [[100, 83]]

fs_setup:
 - cmd: mkfs -F -t %(filesystem)s -L %(label)s %(device)s
   filesystem: ext4
   device: /dev/$dev
   partition: 1
   label: repro

mounts:
 - [/dev/${dev}1, /mnt]
EOF

$ sudo rm -Rf /var/lib/cloud /var/log/cloud-init*
## remove the old entry in /etc/fstab, which can cause LP: #1691489
$ sudo sed -i.dist '/comment=cloudconfig/d' /etc/fstab

## wipe the disk so that we make sure we format it.
$ sudo python3 -c "import sys;
buf = b'\\0' * 1024 * 1024 * 8
with open(sys.argv[1], 'wb+') as fp:
   fp.write(buf)
   fp.seek(-(len(buf)), 2)
   fp.write(buf)" /dev/$dev

$ sudo reboot

## Now ssh back in, and expect to have a filesystem on /dev/vdb1
## that is mounted at /mnt

[Regression Potential]
Regression could occur if a user had provided a string to the 'cmd'
argument that had special shell characters in it.
For example:
 cmd: "/my/cmd *foo*"

That would previously have executed the command "/mnt/cmd *foo*", but
will now execute the command /mnt/cmd with argument shell filename
expansion of *foo*

[Other Info]
Upstream commit at
  https://git.launchpad.net/cloud-init/commit/?id=4f0f171c2

=== End SRU Template ===

This reproduces on Azure, but it should fail similarly elsewhere. Consider repro.yml:

#cloud-config
fs_setup:
    - special:
      cmd: mkfs -t %(filesystem)s -L %(label)s %(device)s
      filesystem: ext4
      device: /dev/sdb1
      label: repro

Create a VM with this cloud config:
$ az vm create -g $rg -l westus2 --custom-data @repro.yml --image UbuntuLTS -n repro2

Then cloud-init will fail with:
Failed to exec of 'mkfs -t ext4 -L repro /dev/sdb1':
Unexpected error while running command.
Command: mkfs -t ext4 -L repro /dev/sdb1
Exit code: -
Reason: [Errno 2] No such file or directory: 'mkfs -t ext4 -L repro /dev/sdb1'

$ dpkg-query -W -f='${Version}' cloud-init
0.7.9-48-g1c795b9-0ubuntu1~16.04.1

Bug is in mkfs() in cc_disk_setup.py, which creates a shell-like string in the case that cmd was specified and a exec-like array in the other case (around line 913).

Related branches

Paul Meyer (paul-meyer) wrote :
Paul Meyer (paul-meyer) wrote :

Additionally, the docs for fs_setup have uppercase mapping keys, while the code expects lowercase keys.

Scott Moser (smoser) on 2017-05-03
Changed in cloud-init:
status: New → Confirmed
importance: Undecided → Medium
Vishnu C (chalil) on 2017-05-03
Changed in cloud-init (Ubuntu):
assignee: nobody → Vishnu C (chalil)
Paul Meyer (paul-meyer) on 2017-05-03
Changed in cloud-init:
assignee: nobody → Paul Meyer (paul-meyer)
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package cloud-init - 0.7.9-144-g2825a917-0ubuntu1

---------------
cloud-init (0.7.9-144-g2825a917-0ubuntu1) artful; urgency=medium

  * New upstream snapshot.
    - flake8: move the pinned version of flake8 up to 3.3.0
    - tests: Apply workaround for snapd bug in test case. [Joshua Powers]
    - RHEL/CentOS: Fix dual stack IPv4/IPv6 configuration. [Andreas Karis]
      (LP: #1679817, #1685534, #1685532)
    - disk_setup: fix several issues with gpt disk partitions. (LP: #1692087)
    - function spelling & docstring update [Joshua Powers]
    - Fixing wrong file name regression. [Joshua Powers]
    - tox: move pylint target to 1.7.1
    - Fix get_interfaces_by_mac for empty macs (LP: #1692028)
    - DigitalOcean: remove routes except for the public interface.
      [Ben Howard] (LP: #1681531.)
    - netplan: pass macaddress, when specified, for vlans
      [Dimitri John Ledkov] (LP: #1690388)
    - doc: various improvements for the docs on cc_users_groups.
      [Felix Dreissig]
    - cc_ntp: write template before installing and add service restart
      [Ryan Harper] (LP: #1645644)
    - cloudstack: fix tests to avoid accessing /var/lib/NetworkManager
      [Lars Kellogg-Stedman]
    - tests: fix hardcoded path to mkfs.ext4 [Joshua Powers] (LP: #1691517)
    - Actually skip warnings when .skip file is present. [Chris Brinker]
      (LP: #1691551)
    - netplan: fix netplan render_network_state signature.
      [Dimitri John Ledkov] (LP: #1685944)
    - Azure: fix reformatting of ephemeral disks on resize to large types.
      (LP: #1686514)
    - Revert "tools/net-convert: fix argument order for render_network_state"
    - make deb: Add devscripts dependency for make deb. Cleanup packages/bddeb.
      [Chad Smith] (LP: #1685935)
    - tools/net-convert: fix argument order for render_network_state
      [Ryan Harper] (LP: #1685944)
    - openstack: fix log message copy/paste typo in _get_url_settings
      [Lars Kellogg-Stedman]
    - unittests: fix unittests run on centos [Joshua Powers]
    - Improve detection of snappy to include os-release and kernel cmdline.
      (LP: #1689944)
    - Add address to config entry generated by _klibc_to_config_entry.
      [Julien Castets] (LP: #1691135)
    - sysconfig: Raise ValueError when multiple default gateways are present.
      [Chad Smith] (LP: #1687485)
    - FreeBSD: improvements and fixes for use on Azure
      [Hongjiang Zhang] (LP: #1636345)
    - Add unit tests for ds-identify, fix Ec2 bug found.
    - fs_setup: if cmd is specified, use shell interpretation.
      [Paul Meyer] (LP: #1687712)
    - doc: document network configuration defaults policy and formats.
      [Ryan Harper]
    - Fix name of "uri" key in docs for "cc_apt_configure" module
      [Felix Dreissig]
    - tests: Enable artful [Joshua Powers]

 -- Scott Moser <email address hidden> Tue, 23 May 2017 17:04:40 -0400

Changed in cloud-init (Ubuntu):
status: New → Fix Released

Hello Paul, or anyone else affected,

Accepted cloud-init into zesty-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/cloud-init/0.7.9-153-g16a7302f-0ubuntu1~17.04.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in cloud-init (Ubuntu Zesty):
status: New → Fix Committed
tags: added: verification-needed
Brian Murray (brian-murray) wrote :

Hello Paul, or anyone else affected,

Accepted cloud-init into yakkety-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/cloud-init/0.7.9-153-g16a7302f-0ubuntu1~16.10.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in cloud-init (Ubuntu Yakkety):
status: New → Fix Committed
Brian Murray (brian-murray) wrote :

Hello Paul, or anyone else affected,

Accepted cloud-init into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/cloud-init/0.7.9-153-g16a7302f-0ubuntu1~16.04.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in cloud-init (Ubuntu Xenial):
status: New → Fix Committed
Joshua Powers (powersj) wrote :

With cloud-init on Xenial from proposed (0.7.9-153-g16a7302f-0ubuntu1~16.04.1) I found the error message is gone, however, I do not see the disk when I do `ls -s /dev/disk/by-id/`, see below:

My steps:
$ az vm create -n cloud-init-test -g $my_group --image ubuntults --data-disk-sizes-gb 8 --size Standard_DS2_v2 --ssh-key-value ~/.ssh/id_rsa.pub

$ ls /dev/sd*
/dev/sda /dev/sda1 /dev/sdb /dev/sdb1 /dev/sdc /dev/sdc1

$ cat /etc/cloud/cloud.cfg.d/disk-setup.cfg
#cloud-config
fs_setup:
    - special:
        cmd: mkfs -t %(filesystem)s -L %(label)s %(device)s
        filesystem: ext4
        device: /dev/sdc1
        label: repronew

$ ls -l /dev/disk/by-label/
total 0
lrwxrwxrwx 1 root root 10 Jun 20 22:57 cloudimg-rootfs -> ../../sda1
lrwxrwxrwx 1 root root 9 Jun 20 22:57 rd_rdfe_stable.161107-1031 -> ../../sr0

I am not sure if I am missing something or if there are better verification steps. In either case , this bug needs a formal SRU template with real test steps.

Stephen A. Zarkos (stevez) wrote :

Testing fails for me on Xenial - here are my steps:

1) Create a VM in Azure (any size)
2) Update cloud-init to the latest in xenial-proposed
3) Capture VM image
4) Provision a new VM using the following cloud-config:

#cloud-config
 fs_setup:
     - special:
       cmd: mkfs -t %(filesystem)s -L %(label)s %(device)s
       filesystem: ext4
       device: /dev/sdb1
       label: repro

I see the following logs in cloud-init.log:

2017-06-22 17:18:49,995 - cc_disk_setup.py[DEBUG]: setting up filesystems: [{'cmd': 'mkfs -t %(filesystem)s -L %(label)s %(device)s', 'filesystem': 'ext4', 'special': None, 'device': '/dev/sdb1', 'label': 'repro'}]
2017-06-22 17:18:49,995 - cc_disk_setup.py[DEBUG]: Creating new filesystem.
2017-06-22 17:18:49,996 - util.py[DEBUG]: Running command ['udevadm', 'settle'] with allowed return codes [0] (shell=False, capture=True)
2017-06-22 17:18:50,279 - cc_disk_setup.py[DEBUG]: Checking /dev/sdb1 against default devices
2017-06-22 17:18:50,279 - cc_disk_setup.py[DEBUG]: Identifying device to create repro filesytem on
2017-06-22 17:18:50,280 - util.py[DEBUG]: Running command ['/bin/lsblk', '--pairs', '--output', 'NAME,TYPE,FSTYPE,LABEL', '/dev/sdb1'] with allowed return codes [0] (shell=False, capture=True)
2017-06-22 17:18:50,299 - cc_disk_setup.py[WARNING]: Failed to find device during available device search.
2017-06-22 17:18:50,308 - cc_disk_setup.py[DEBUG]: Automatic device for /dev/sdb1 identified as None
2017-06-22 17:18:50,308 - cc_disk_setup.py[DEBUG]: No device aviable that matches request. Skipping fs creation for {'cmd': 'mkfs -t %(filesystem)s -L %(label)s %(device)s', 'filesystem': 'ext4', 'special': None, 'device': '/dev/sdb1', 'label': 'repro'}
2017-06-22 17:18:50,308 - util.py[DEBUG]: Creating fs for /dev/sdb1 took 0.313 seconds
2017-06-22 17:18:50,309 - handlers.py[DEBUG]: finish: init-network/config-disk_setup: SUCCESS: config-disk_setup ran successfully

David Britton (davidpbritton) wrote :

I recommend to back this change out and re-approach. 2 major things we found during testing

1) While this solution fixes the example given in the docs and the bug description, another error is hit as seen in comment #7 and comment #8. This needs debugging.

2) no protection against an array being specified originally. I.e., if someone had a config like this they are now broken:

#cloud-config
 fs_setup:
     - special:
       cmd: [ "mkfs", "-t" ... ]

The commit to back out appears to be 4f0f171c29bb9abb5cbb6f9adbe68015089aeed9

Dimitri John Ledkov (xnox) wrote :

Based on the above comments, I understand that the proposed update does not resolve this bug, but does it make things worse?

E.g. can the pending update be released to fix all the other bugs that were validated correctly, and reopen this bug report to re-fix this issue again?

Scott Moser (smoser) on 2017-06-26
Changed in cloud-init (Ubuntu):
importance: Undecided → Medium
Changed in cloud-init (Ubuntu Xenial):
importance: Undecided → Medium
Changed in cloud-init (Ubuntu Yakkety):
importance: Undecided → Medium
Changed in cloud-init (Ubuntu Zesty):
importance: Undecided → Medium
Scott Moser (smoser) wrote :

David, for your point '2' above (comment 9), there was never any support for cmd being an array. That is something that could be added, but is not a regression.

See the previous code at
 https://git.launchpad.net/cloud-init/tree/cloudinit/config/cc_disk_setup.py?id=99faf3ece1badc566e7e75e769ff374250196197#n912

And the changes made at
  https://git.launchpad.net/cloud-init/commit/?id=4f0f171c29bb9abb5cbb6f9adbe68015089aeed9

Scott Moser (smoser) wrote :

I've updated the SRU template providing one that should work.
The original config provided did not have any way to create a partitioned device , but tried to put a filesystem on the first partition.

description: updated
Joshua Powers (powersj) wrote :

First, reproduced and verified the mount was not succeeding. Then, upgraded to the version in proposed and rebooted confirm that the disk was mounted. Used the following cmd to boot an instance in azure with the following cloud-config:

$ az vm create -n ci-test-1687712-$release -g $group --image $release_img --data-disk-sizes-gb 8 --size Standard_DS2_v2 --ssh-key-value ~/.ssh/id_rsa.pub --custom-data setup.cfg
$ cat setup.cfg
#cloud-config
disk_setup:
  /dev/sdc:
    table_type: gpt
    layout: [[100, 83]]

fs_setup:
 - cmd: mkfs -F -t %(filesystem)s -L %(label)s %(device)s
   filesystem: ext4
   device: /dev/sdc
   partition: 1
   label: repro

mounts:
 - [/dev/sdc1, /repro]

* xenial (0.7.9-153-g16a7302f-0ubuntu1~16.04.1)
* yakkety (0.7.9-153-g16a7302f-0ubuntu1~16.10.1)
* zesty (0.7.9-153-g16a7302f-0ubuntu1~17.04.1)

Marking verification done.

tags: added: verification-done-xenial verification-done-yakkety verification-done-zesty
removed: verification-needed
Launchpad Janitor (janitor) wrote :
Download full text (3.4 KiB)

This bug was fixed in the package cloud-init - 0.7.9-153-g16a7302f-0ubuntu1~17.04.1

---------------
cloud-init (0.7.9-153-g16a7302f-0ubuntu1~17.04.1) zesty-proposed; urgency=medium

  * New upstream snapshot.
    - net: fix reading and rendering addresses in cidr format.
      [Dimitri John Ledkov] (LP: #1689346, #1684349)
    - disk_setup: udev settle before attempting partitioning or fs creation.
      (LP: #1692093)
    - GCE: Update the attribute used to find instance SSH keys.
      [Daniel Watkins] (LP: #1693582)
    - nplan: For bonds, allow dashed or underscore names of keys.
      [Dimitri John Ledkov] (LP: #1690480)
    - tests: python2.6: fix unit tests usage of assertNone and format.
    - tests: update docstring on test_configured_list_with_none
    - fix tools/ds-identify to not write None twice.
    - tox/build: do not package depend on style requirements.
    - tests: ntp: Restructure cc_ntp unit tests. [Chad Smith]
    - flake8: move the pinned version of flake8 up to 3.3.0
    - tests: Apply workaround for snapd bug in test case. [Joshua Powers]
    - RHEL/CentOS: Fix dual stack IPv4/IPv6 configuration. [Andreas Karis]
    - disk_setup: fix several issues with gpt disk partitions. (LP: #1692087)
    - function spelling & docstring update [Joshua Powers]
    - tests: Fix unittest bug in ntp tests. [Joshua Powers]
    - tox: move pylint target to 1.7.1
    - Fix get_interfaces_by_mac for empty macs (LP: #1692028)
    - DigitalOcean: remove routes except for the public interface.
      [Ben Howard] (LP: #1681531.)
    - netplan: pass macaddress, when specified, for vlans
      [Dimitri John Ledkov] (LP: #1690388)
    - doc: various improvements for the docs on cc_users_groups.
      [Felix Dreissig]
    - cc_ntp: write template before installing and add service restart
      [Ryan Harper] (LP: #1645644)
    - tests: fix cloudstack unit tests to avoid accessing
      /var/lib/NetworkManager [Lars Kellogg-Stedman]
    - tests: fix hardcoded path to mkfs.ext4 [Joshua Powers] (LP: #1691517)
    - Actually skip warnings when .skip file is present.
      [Chris Brinker] (LP: #1691551)
    - netplan: fix netplan render_network_state signature.
      [Dimitri John Ledkov] (LP: #1685944)
    - Azure: fix reformatting of ephemeral disks on resize to large types.
      (LP: #1686514)
    - make deb: Add devscripts dependency for make deb.
      Cleanup packages/bddeb. [Chad Smith] (LP: #1685935)
    - openstack: fix log message copy/paste typo in _get_url_settings
      [Lars Kellogg-Stedman]
    - unittests: fix unittests run on centos [Joshua Powers]
    - Improve detection of snappy to include os-release and kernel cmdline.
      (LP: #1689944)
    - Add address to config entry generated by _klibc_to_config_entry.
      [Julien Castets] (LP: #1691135)
    - sysconfig: Raise ValueError when multiple default gateways are present.
      [Chad Smith] (LP: #1687485)
    - FreeBSD: improvements and fixes for use on Azure
      [Hongjiang Zhang] (LP: #1636345)
    - Add unit tests for ds-identify, fix Ec2 bug found.
    - fs_setup: if cmd is specified, use shell interpretation.
      [Paul Meyer] (LP: #1687712)
    - doc: document network c...

Read more...

Changed in cloud-init (Ubuntu Zesty):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for cloud-init has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Launchpad Janitor (janitor) wrote :
Download full text (3.4 KiB)

This bug was fixed in the package cloud-init - 0.7.9-153-g16a7302f-0ubuntu1~16.10.1

---------------
cloud-init (0.7.9-153-g16a7302f-0ubuntu1~16.10.1) yakkety-proposed; urgency=medium

  * New upstream snapshot.
    - net: fix reading and rendering addresses in cidr format.
      [Dimitri John Ledkov] (LP: #1689346, #1684349)
    - disk_setup: udev settle before attempting partitioning or fs creation.
      (LP: #1692093)
    - GCE: Update the attribute used to find instance SSH keys.
      [Daniel Watkins] (LP: #1693582)
    - nplan: For bonds, allow dashed or underscore names of keys.
      [Dimitri John Ledkov] (LP: #1690480)
    - tests: python2.6: fix unit tests usage of assertNone and format.
    - tests: update docstring on test_configured_list_with_none
    - fix tools/ds-identify to not write None twice.
    - tox/build: do not package depend on style requirements.
    - tests: ntp: Restructure cc_ntp unit tests. [Chad Smith]
    - flake8: move the pinned version of flake8 up to 3.3.0
    - tests: Apply workaround for snapd bug in test case. [Joshua Powers]
    - RHEL/CentOS: Fix dual stack IPv4/IPv6 configuration. [Andreas Karis]
    - disk_setup: fix several issues with gpt disk partitions. (LP: #1692087)
    - function spelling & docstring update [Joshua Powers]
    - tests: Fix unittest bug in ntp tests. [Joshua Powers]
    - tox: move pylint target to 1.7.1
    - Fix get_interfaces_by_mac for empty macs (LP: #1692028)
    - DigitalOcean: remove routes except for the public interface.
      [Ben Howard] (LP: #1681531.)
    - netplan: pass macaddress, when specified, for vlans
      [Dimitri John Ledkov] (LP: #1690388)
    - doc: various improvements for the docs on cc_users_groups.
      [Felix Dreissig]
    - cc_ntp: write template before installing and add service restart
      [Ryan Harper] (LP: #1645644)
    - tests: fix cloudstack unit tests to avoid accessing
      /var/lib/NetworkManager [Lars Kellogg-Stedman]
    - tests: fix hardcoded path to mkfs.ext4 [Joshua Powers] (LP: #1691517)
    - Actually skip warnings when .skip file is present.
      [Chris Brinker] (LP: #1691551)
    - netplan: fix netplan render_network_state signature.
      [Dimitri John Ledkov] (LP: #1685944)
    - Azure: fix reformatting of ephemeral disks on resize to large types.
      (LP: #1686514)
    - make deb: Add devscripts dependency for make deb.
      Cleanup packages/bddeb. [Chad Smith] (LP: #1685935)
    - openstack: fix log message copy/paste typo in _get_url_settings
      [Lars Kellogg-Stedman]
    - unittests: fix unittests run on centos [Joshua Powers]
    - Improve detection of snappy to include os-release and kernel cmdline.
      (LP: #1689944)
    - Add address to config entry generated by _klibc_to_config_entry.
      [Julien Castets] (LP: #1691135)
    - sysconfig: Raise ValueError when multiple default gateways are present.
      [Chad Smith] (LP: #1687485)
    - FreeBSD: improvements and fixes for use on Azure
      [Hongjiang Zhang] (LP: #1636345)
    - Add unit tests for ds-identify, fix Ec2 bug found.
    - fs_setup: if cmd is specified, use shell interpretation.
      [Paul Meyer] (LP: #1687712)
    - doc: document network...

Read more...

Changed in cloud-init (Ubuntu Yakkety):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :
Download full text (3.4 KiB)

This bug was fixed in the package cloud-init - 0.7.9-153-g16a7302f-0ubuntu1~16.04.1

---------------
cloud-init (0.7.9-153-g16a7302f-0ubuntu1~16.04.1) xenial-proposed; urgency=medium

  * New upstream snapshot.
    - net: fix reading and rendering addresses in cidr format.
      [Dimitri John Ledkov] (LP: #1689346, #1684349)
    - disk_setup: udev settle before attempting partitioning or fs creation.
      (LP: #1692093)
    - GCE: Update the attribute used to find instance SSH keys.
      [Daniel Watkins] (LP: #1693582)
    - nplan: For bonds, allow dashed or underscore names of keys.
      [Dimitri John Ledkov] (LP: #1690480)
    - tests: python2.6: fix unit tests usage of assertNone and format.
    - tests: update docstring on test_configured_list_with_none
    - fix tools/ds-identify to not write None twice.
    - tox/build: do not package depend on style requirements.
    - tests: ntp: Restructure cc_ntp unit tests. [Chad Smith]
    - flake8: move the pinned version of flake8 up to 3.3.0
    - tests: Apply workaround for snapd bug in test case. [Joshua Powers]
    - RHEL/CentOS: Fix dual stack IPv4/IPv6 configuration. [Andreas Karis]
    - disk_setup: fix several issues with gpt disk partitions. (LP: #1692087)
    - function spelling & docstring update [Joshua Powers]
    - tests: Fix unittest bug in ntp tests. [Joshua Powers]
    - tox: move pylint target to 1.7.1
    - Fix get_interfaces_by_mac for empty macs (LP: #1692028)
    - DigitalOcean: remove routes except for the public interface.
      [Ben Howard] (LP: #1681531.)
    - netplan: pass macaddress, when specified, for vlans
      [Dimitri John Ledkov] (LP: #1690388)
    - doc: various improvements for the docs on cc_users_groups.
      [Felix Dreissig]
    - cc_ntp: write template before installing and add service restart
      [Ryan Harper] (LP: #1645644)
    - tests: fix cloudstack unit tests to avoid accessing
      /var/lib/NetworkManager [Lars Kellogg-Stedman]
    - tests: fix hardcoded path to mkfs.ext4 [Joshua Powers] (LP: #1691517)
    - Actually skip warnings when .skip file is present.
      [Chris Brinker] (LP: #1691551)
    - netplan: fix netplan render_network_state signature.
      [Dimitri John Ledkov] (LP: #1685944)
    - Azure: fix reformatting of ephemeral disks on resize to large types.
      (LP: #1686514)
    - make deb: Add devscripts dependency for make deb.
      Cleanup packages/bddeb. [Chad Smith] (LP: #1685935)
    - openstack: fix log message copy/paste typo in _get_url_settings
      [Lars Kellogg-Stedman]
    - unittests: fix unittests run on centos [Joshua Powers]
    - Improve detection of snappy to include os-release and kernel cmdline.
      (LP: #1689944)
    - Add address to config entry generated by _klibc_to_config_entry.
      [Julien Castets] (LP: #1691135)
    - sysconfig: Raise ValueError when multiple default gateways are present.
      [Chad Smith] (LP: #1687485)
    - FreeBSD: improvements and fixes for use on Azure
      [Hongjiang Zhang] (LP: #1636345)
    - Add unit tests for ds-identify, fix Ec2 bug found.
    - fs_setup: if cmd is specified, use shell interpretation.
      [Paul Meyer] (LP: #1687712)
    - doc: document network ...

Read more...

Changed in cloud-init (Ubuntu Xenial):
status: Fix Committed → Fix Released

This bug is believed to be fixed in cloud-init in 17.1. If this is still a problem for you, please make a comment and set the state back to New

Thank you.

Changed in cloud-init:
status: Confirmed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Bug attachments